% signet(1)
% Adam
% May 2023


# NAME
signet - Application to access the Signet hardware password manager


# SYNOPSIS
signet [OPTION]...


# DESCRIPTION
Application to access encrypted passwords on a Signet hardware device. After
launching the application, it will search for a Signet and if one is found,
the graphical interface will prompt for the signet's password. After that is
corectly entered the Signet device can decrypt its storage and display the
accounts that are available.

The user selects the entry and field they want and the application requests that
data from the hardware. This causes the device to illuminate, indicating that
pressing the physical button on the device within the 10 second timeout will
cause the device to act as a keyboard and type the requested field.

The user is expected to use this 10 seconds to switch to the application where
they want their password to be typed before pressing the button on the Signet.


# OPTIONS
**--file FILENAME**
: Read database from specified file

**-h, --help**
: Displays help on commandline options.

**--help-all**
: Displays help including Qt specific options.

**--start-in-systray**
: Start application minimized in the system tray

**--qmljsdebugger VALUE**
: Activates the QML/JS debugger with a specified port. The value must be of
format port:1234[,block]. "block" makes the application wait for a connection.

**--platform PLATFORMNAME[:OPTIONS]>**
: QPA plugin. See QGuiApplication documentation for available options for each
plugin.

**--platformpluginpath PATH**
: Path to the platform plugins.

**--platformtheme THEME**
: Platform theme.

**--plugin PLUGIN**
: Additional plugins to load, can be specified multiple times.

**--qwindowgeometry GEOMETRY**
: Window geometry for the main window, using the X11-syntax, like 100x100+50+50.

**--qwindowicon ICON**
: Default window icon.

**--qwindowtitle TITLE**
: Title of the first window.

**--reverse**
: Sets the application's layout direction to Qt::RightToLeft (debugging helper).

**--session SESSION**
: Restores the application from an earlier session.

**--display DISPLAY**
: Display name, overrides $DISPLAY.

**--name NAME**
: Instance name according to ICCCM 4.1.2.5.

**--nograb**
: Disable mouse grabbing (useful in debuggers).

**--dograb**
: Force mouse grabbing (even when running in a debugger).

**--visual ID**
: ID of the X11 Visual to use.

**--geometry GEOMETRY**
: Alias for --qwindowgeometry.

**--icon ICON**
: Alias for --qwindowicon.

**--title TITLE**
: Alias for --qwindowtitle.


# EXAMPLES
signet --start-in-systray


# EXIT VALUES
**0**
: Success


# BUGS
Application does not continuously re-scan to detect devices. The application
must be started after the Signet hardware is inserted.

